## schrankwand.py
"""Version für die Moebelgruppe"""
from leinwand import Leinwand
from moebelgruppe import Moebelgruppe
from schrank import Schrank
class Schrankwand(Moebelgruppe):
    """
    Stellt eine  Schrankwand mit drei Schränken im Möbelplaner dar.
    Version mit Verwendungsbeziehung bei flexibler Anzahl
    """
    def __init__(self,
                 anzahl,
                 xPosition=50,
                 yPosition=50,
                 schrankbreite=60,
                 schranktiefe=37,
                 winkel=0,
                 randfarbe='braun'):
        """
        Erzeugt eine Schrankwand an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte der Schrankwand
        yPosition: die y-Koordinate der Mitte der Schrankwand
        randfarbe: die Randfarbe, in der der Schrank angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        super().__init__(xPosition,yPosition,winkel,randfarbe)
        self.__schrankbreite=schrankbreite
        self.__schranktiefe=schranktiefe
        self.__anzahl=anzahl
        self._fuegeAlleHinzu()

    def _fuegeAlleHinzu(self):
        x,y=self.gibX(),self.gibY()
        for i in range(self.__anzahl):
            self.fuegeHinzu(Schrank(x+i*self.__schrankbreite,y,
                                    self.__schrankbreite,self.__schranktiefe,0,
                                    self.gibRF()))

    def fuegeEinenHinzu(self):
        '''fügt einen weiteren Schrank am Ende hinzu'''
        self.fuegeHinzu(Schrank(self.__anzahl*self.__schrankbreite,0,
                                self.__schrankbreite,self.__schranktiefe,
                                0,self.gibRF()))
        self.__anzahl+=1
    
    def entferneLetzten(self):
        '''entfernt den letzten Schrank'''
        if self.__anzahl==0: return
        self.entferne(self.gibMoebel(self.__anzahl))
        self.__anzahl-=1
