from leinwand import Leinwand
from moebel import Moebel
class Stuhl(Moebel):
    """
    Stellt einen Stuhl im Möbelplaner dar.
    """
    def __init__(self,xPosition=20,yPosition=20,breite=40,tiefe=40,winkel=0,randfarbe='rot'):
        """
        Erzeugt einen Stuhl an der gegebenen Position.
        xPosition: die x-Koordinate der oberen linken Ecke des Stuhls
        yPosition: die y-Koordinate der oberen linken Ecke des Stuhls
        randfarbe: die Randfarbe, in der der Stuhl angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        super().__init__(xPosition,yPosition,breite,tiefe,winkel,randfarbe)

    def erzeugeFigur(self):
        """
        Erzeugt die Darstellung dieses Stuhls im Möbelplaner.
        """
        if not self.gibFormen():
            x,y,b,t,lw = self.gibX(),self.gibY(),self.gibB(),self.gibT(),self.gibLW()
            formen = []
            sitzflaeche = lw.polygon(x,y, x+b,y, x+b+5,y+t, x-5,y+t)
            formen.append(sitzflaeche)
            rueckenlehne = lw.linie(x-1,y+5,x+b+1,y+5)
            formen.append(rueckenlehne)
            return formen
