from leinwand import Leinwand
from moebel import Moebel
class Tisch(Moebel):
    """
    Stellt einen Tisch im Möbelplaner dar.
    """
    def __init__(self,xPosition=50,yPosition=50,breite=120,tiefe=60,winkel=0,randfarbe='blau'):
        """
        Erzeugt einen Tisch an der gegebenen Position.
        xPosition: die x-Koordinate der Mitte des Tischs
        yPosition: die y-Koordinate der Mitte des Tischs
        randfarbe: die Randfarbe, in der der Tisch angezeigt werden soll.
               Dies sollte einer der Farbnamen der Klasse Farben sein.  
        """
        super().__init__(xPosition,yPosition,breite,tiefe,winkel,randfarbe)

    def erzeugeFigur(self):
        """
        Erzeugt die Figur, die einen Tisch auf der Leinwand darstellt.
        """
        if not self.gibFormen():
            x,y,b,t,lw = self.gibX(),self.gibY(),self.gibB(),self.gibT(),self.gibLW()
            formen = []
            tisch = lw.polygon(x,y, x+b,y, x+b,y+t, x,y+t)
            formen.append(tisch)
            return formen

