# tischgruppe Kompositum.py
# Fortsetzung der Entwicklung auf eine Tischgruppe
# mit den Methoden FuegeHinzu() und Entferne()
# und mit _AktualisiereAbmessungen() in Moebelgruppe

# Umsetzen des Kompositummusters

from moebelgruppe import Moebelgruppe
from tisch import Tisch
from stuhl import Stuhl

### ---------------------------------------------------
class Tischgruppe(Moebelgruppe):
    '''Die Klasse Tischgruppe erzeugt automatisch die Objekte,
    ein Tischobjekt und mehrere Stuhlobjekte.
    Begonnen wird mit einer leeren Tischgruppe, der durch
    Konfigurieren die notwendigen Teile definiert werden.
    Umsetzung des Kompositummusters in Transformiere von Moebel.'''
    def __init__(self,
                 xPos=50,
                 yPos=50,
                 winkel=0,
                 farbe="black",
                 sichtbar=False):
        Moebelgruppe.__init__(self, xPos, yPos, winkel, farbe)
        self.__stuehle_inBreite,self.__stuehle_inTiefe = 0,0
        self.setzeStuehle(0,0)
        # Stuhlabstand statisch 10

    def setzeStuehle(self, inBreite=2, inTiefe=1):
        '''setzt die Anzahl der Stuehle an der einen Kante
        und der anderen Kante'''
        self.__stuehle_inBreite,self.__stuehle_inTiefe = inBreite,inTiefe
        self._fuegeAlleHinzu()
        
    def _fuegeAlleHinzu(self):
        """die Tischgruppe wird neu erzeugt"""
        if 0 in [self.__stuehle_inBreite,self.__stuehle_inTiefe]: return
        for moebel in []+self.gibAlle(): # echte Kopie
            self.entferne(moebel)
            del(moebel)
        stuhlBreite,stuhlTiefe=40,40
        x,y=self.gibX(),self.gibY()
        dX_und_Y=stuhlTiefe+10
        stuhl1=Stuhl(x,y+dX_und_Y+10,stuhlBreite,stuhlTiefe,270,'blau') # am Kopf
        self.fuegeHinzu(stuhl1)
        tischBreite=self.__stuehle_inBreite*(stuhlBreite+20)
        tischTiefe=self.__stuehle_inTiefe*(stuhlTiefe+20)
        self.fuegeHinzu(Tisch(x+dX_und_Y,y+dX_und_Y,tischBreite,tischTiefe,0,'rot'))
        for i in range(self.__stuehle_inBreite):
            self.fuegeHinzu(Stuhl(x+dX_und_Y+10+i*(stuhlBreite+20),y,
                                  stuhlBreite,stuhlTiefe,0,'blau'))
            self.fuegeHinzu(Stuhl(x+dX_und_Y+10+i*(stuhlBreite+20),
                                  y+dX_und_Y+10+tischTiefe,
                                  stuhlBreite,stuhlTiefe,180,'blau'))
        for i in range(self.__stuehle_inTiefe):
            if i>0: # ersten nicht doppelt
                self.fuegeHinzu(Stuhl(x,y+dX_und_Y+10+i*(stuhlTiefe+20),
                                      stuhlBreite,stuhlTiefe,270,'blau'))
            self.fuegeHinzu(Stuhl(x+dX_und_Y+10+tischBreite,
                                  y+dX_und_Y+10+i*(stuhlTiefe+20),
                                  stuhlBreite,stuhlTiefe,90,'blau'))

